unit progressDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TProgressDialog = class(TForm)
    ProgressBar1: TProgressBar;
    CancelButton: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private declarations }
    FClosed: boolean;
    FStartTime: DWORD;
  public
    { Public declarations }
    procedure Start(maxVariation: integer);
    procedure StepIt;
    function Stopped: boolean;
  end;

var
  ProgressDialog: TProgressDialog;

implementation
uses
  mmsystem;

{$R *.dfm}

procedure TProgressDialog.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TProgressDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Action = caHide then
    FCLosed := true;
end;

procedure TProgressDialog.Start(maxVariation: integer);
begin
  Hide;
  ProgressBar1.Max := maxVariation - 1;
  ProgressBar1.Step := 1;
  ProgressBar1.Position := 0;
  FClosed := false;
  FStartTime := timeGetTime;
  //Show;
  //Update;
end;

procedure TProgressDialog.StepIt;
begin
  if (not Visible) and ((timeGetTime - FStartTime) > 1000) then
  begin
    Show;
    Update;
  end;
  ProgressBar1.StepIt;
  Application.ProcessMessages;
end;

function TProgressDialog.Stopped: boolean;
begin
  result := FClosed;
end;

end.
